 //     PORTD.  -  ,   .

#include <mega16.h> 
#define n 5 //  .     
 
unsigned char knop_1 = 0xFF; /*   
                                PIND */
unsigned char knop_2 = 0xFF; /*      PIND  
                                  */ 
unsigned int t_oprosa = 0; //   

//     
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
t_oprosa++;
if (t_oprosa < n) return;
if (knop_1 == PIND) 
    knop_2 = knop_1;            
knop_1 = PIND;
t_oprosa = 0;
if ((PORTD != knop_2) && (knop_2 != 0xFF)) 
    PORTD = knop_2;
DDRD=~PORTD;
}

void main(void)
{
//   
PORTD=0xFF;
DDRD=0x00;

TCCR1B=0x02;

TIMSK=0x04;

ACSR=0x80;
SFIOR=0x00;

#asm("sei") //   

while (1); //  .     
}
